#Made by Mads Juul 2014. Contact : mjstoryboard@gmail.com 
import sys
import os
import subprocess

def getDuration(myFile):
    myReturn = 0
    result = subprocess.Popen(["ffmpeg", "-i" ,myFile],stdout = subprocess.PIPE, stderr = subprocess.STDOUT)
    for x in result.stdout.readlines():
        thethe =  str(x)
        if "Duration" in thethe:
            theSplit = thethe.split(" ")[3].split(",")[0]
            myReturn =  theSplit

    return myReturn


quality = '18'
burnName = 0
fontSize = '22'
#WINDOWS
fontFile = '/Windows/Fonts/arial.ttf'
#MAC
#fontFile="/Library/Fonts/Andale Mono.ttf"
#LINUX
#fontFile="/usr/share/fonts/truetype/droid/DroidSansMono.ttf"
scaleVideo = 0
outputSize = '1024:576'
deleteAVI = 0


renderFolder=os.path.dirname(__file__)
names = os.listdir(renderFolder)

for name in names:
    fileName, fileExtension = os.path.splitext(name)
    if fileExtension=='.avi' or fileExtension=='.AVI' :
        myIn=renderFolder+"\\"+name
        myOut=renderFolder+"\\"+fileName+".mp4"
      
        tempSound=renderFolder+"\\"+fileName+".wav"
        dur = getDuration(myIn)
        command = 'ffmpeg -y -f lavfi -i aevalsrc=0  -i '+myIn+' -filter_complex amix=inputs=2:duration=first:dropout_transition=0 -q:a 0  -t '+dur+' '+tempSound
        subprocess.call(command)
        if not os.path.exists(tempSound):
            command = 'ffmpeg -y -f lavfi -i aevalsrc=0 -t '+dur+' -strict experimental -ar 48000  '+tempSound
            subprocess.call(command)
       
        command = 'ffmpeg -y -i '+myIn+' -i '+tempSound+' -map 0:0 -map 1 -c:v libx264 -preset veryslow -crf '+quality+' -profile:v baseline -pix_fmt yuv420p  -ac 1 -c:a libvo_aacenc -b:a 128000 -ar 48000 '

        if burnName:
            mySplit = fileName.split("_",2)
            name = mySplit[0]
            command = command+'-vf [in]'
            if scaleVideo:
                command = command+'scale='+outputSize+','
            command = command+'drawtext=fontfile='+fontFile+':text='+name+':fontsize='+fontSize+'[out]'
        else:
            if scaleVideo:
                command = command+'-vf [in]scale='+outputSize+'[out]'
        command = command+' '+myOut    
        subprocess.call(command)
        os.remove(tempSound)
        if deleteAVI:
            if os.path.exists(myIn):
                os.remove(myIn)









       
        
