#Made by Mads Juul 2014. Contact : mjstoryboard@gmail.com
import os
#import time
import datetime
import subprocess



curFolder = os.path.dirname(__file__)
parentFolder = os.path.dirname(curFolder)
mp4Folder = curFolder
outputFolder = curFolder

quality='28'
now = datetime.datetime.now()
myDate = now.strftime("%Y%m%d")


concatOutput = mp4Folder+"\\concat.mp4"
mergedOutputName = "MERGED_"+myDate+'.mp4'
mergedOutput = outputFolder+"\\"+mergedOutputName


command = 'ffmpeg -i "concat:'

names = os.listdir(mp4Folder)
count=0
interFiles = [0]
for name in names:
    fileName = os.path.splitext(name)[0]
    fileExtension = os.path.splitext(name)[1]
    myIn=mp4Folder+"\\"+name
    if fileExtension=='.mp4' and name!=mergedOutput:
        myInterFile = mp4Folder+"\\"+fileName+'.ts'
        subprocess.call('ffmpeg -i '+myIn+' -c copy -bsf:v h264_mp4toannexb -f mpegts -y -ac 1 -ar 48000 '+myInterFile)
       
        if count==0:
            command = command+myInterFile
            interFiles[0]= myInterFile
        else:
            command = command+'|'+myInterFile
            interFiles.append(myInterFile)
        count=count+1

if count>1:
    command = command+'" -c copy -bsf:a aac_adtstoasc -y '+concatOutput
    subprocess.call(command)
    for file in interFiles:
        os.remove(file)
            
    command = 'ffmpeg -y -i '+concatOutput+' -c:v libx264 -preset fast -crf '+quality+' -profile:v baseline -q:a 0 -ar 48000 -pix_fmt yuv420p '+mergedOutput
            
    subprocess.call(command)
    os.remove(concatOutput)
    
input("FINISHED! (HIT ANY KEY)")
    





